Forked from
Glasgow Haskell Compiler / GHC
67719 commits behind the upstream repository.
Code owners
Assign users and groups as approvers for specific file changes. Learn more.
configure.in 18.49 KiB
dnl == autoconf source for the Glasgow FP tools ==
dnl (grep for '^dnl' to see the outline of this file)
dnl
dnl * INITIAL SETUP, CHOICE OF PLATFORM(S)
#!/bin/sh
#
# (c) The AQUA Project, Glasgow University, 1994-1997
#
# Configure script for the Glasgow functional programming tools
# (created automagically by autoconf...do not edit by hand)
#
# Do "./configure --help" to see what flags are available.
# (Better yet, read the documentation!)
#
# First off, a distrib sanity check..
AC_INIT(mk/config.mk.in)
# -------------------------------------------------------------------------
# Prepare to generate the following header files
#
#
AC_CONFIG_HEADER(mk/config.h)
# No, we don't do `--srcdir'...
if test x"$srcdir" != 'x.' ; then
echo "This configuration does not support the \`--srcdir' option.."
exit 1
fi
#
# Remove some automounter nonsense (Glasgow specific gruff)
#
hardtop=`pwd`
hardtop=`echo $hardtop | sed 's|^/tmp_mnt/|/|' | sed 's|^/grasp_tmp|/local/grasp_tmp|'`
#OLD: hardtop=`echo $hardtop | sed 's|^/tmp_mnt/|/|' | sed 's|^/export/|/|' | sed 's|^/grasp_tmp|/local/grasp_tmp|'`
echo ''
echo "*** The top of your build tree is: $hardtop"
AC_SUBST(hardtop)
# -------------------------------------------------------------------------
dnl ** choose host(/target/build) platform
#
# Guess host/target/build platform(s) if necessary.
#
AC_CANONICAL_SYSTEM
# "$host" defaults to "$target"
if test "x$host" = xNONE ; then
host=$target
fi
# "$build" defaults to "$host"
#if test "x$build" = xNONE ; then
# build=$host
#else
# echo "This configuration does not support the \`--build' option."
# exit 1
#fi
dnl ** canonicalize platform names
# Canonicali[sz]e those babies
BuildPlatform=`/bin/sh $srcdir/config.sub $build` || exit 1
HostPlatform=`/bin/sh $srcdir/config.sub $host` || exit 1
TargetPlatform=`/bin/sh $srcdir/config.sub $target` || exit 1
if test x"$TargetPlatform" != x"$HostPlatform" ; then
echo "GHC configuration does not support differing host/target (i.e., cross-compiling)"
exit 1
fi
#
# The following will be more difficult when we *are* cross-compiling.
# Suitable names to slam in *_CPP are in platform.h.in.
# We also record the architecture, vendor, and operating system (OS)
# separately.
case $HostPlatform in
alpha-dec-osf[[1234]]*)
HostPlatform=alpha-dec-osf1 # canonicalise for our purposes
TargetPlatform=alpha-dec-osf1 # this will work for now... (hack)
BuildPlatform=alpha-dec-osf1 # hack
HostPlatform_CPP='alpha_dec_osf1'
HostArch_CPP='alpha'
HostVendor_CPP='dec'
HostOS_CPP='osf1'
;;
hppa1.1-hp-hpux*)
HostPlatform=hppa1.1-hp-hpux # canonicalise for our purposes (hack)
TargetPlatform=hppa1.1-hp-hpux
BuildPlatform=hppa1.1-hp-hpux
HostPlatform_CPP='hppa1_1_hp_hpux'
HostArch_CPP='hppa1_1'
HostVendor_CPP='hp'
HostOS_CPP='hpux'
;;
i[[3456]]86-*-linuxaout*)
HostPlatform=i386-unknown-linuxaout # hack again
TargetPlatform=i386-unknown-linuxaout
BuildPlatform=i386-unknown-linuxaout
HostPlatform_CPP='i386_unknown_linuxaout'
HostArch_CPP='i386'
HostVendor_CPP='unknown'
HostOS_CPP='linuxaout'
;;
i[[3456]]86-*-linux*)
HostPlatform=i386-unknown-linux # hack again
TargetPlatform=i386-unknown-linux
BuildPlatform=i386-unknown-linux
HostPlatform_CPP='i386_unknown_linux'
HostArch_CPP='i386'
HostVendor_CPP='unknown'
HostOS_CPP='linux'
;;
i[[3456]]86-*-freebsd*)
HostPlatform=i386-unknown-freebsd # hack again
TargetPlatform=i386-unknown-freebsd
BuildPlatform=i386-unknown-freebsd
HostPlatform_CPP='i386_unknown_freebsd'
HostArch_CPP='i386'
HostVendor_CPP='unknown'
HostOS_CPP='freebsd'
;;
i[[3456]]86-*-netbsd*)
HostPlatform=i386-unknown-netbsd # hack again
TargetPlatform=i386-unknown-netbsd
BuildPlatform=i386-unknown-netbsd
HostPlatform_CPP='i386_unknown_netbsd'
HostArch_CPP='i386'
HostVendor_CPP='unknown'
HostOS_CPP='netbsd'
;;
i[[3456]]86-*-solaris2*)
HostPlatform=i386-unknown-solaris2 # hack again
TargetPlatform=i386-unknown-solaris2
BuildPlatform=i386-unknown-solaris2
HostPlatform_CPP='i386_unknown_solaris2'
HostArch_CPP='i386'
HostVendor_CPP='unknown'
HostOS_CPP='solaris2'
;;
i[[3456]]86-*-cygwin32*)
HostPlatform=i386-unknown-cygwin32 # hack again
TargetPlatform=i386-unknown-cygwin32
BuildPlatform=i386-unknown-cygwin32
HostPlatform_CPP='i386_unknown_cygwin32'
HostArch_CPP='i386'
HostVendor_CPP='unknown'
HostOS_CPP='cygwin32'
;;
m68k-next-nextstep2)
HostPlatform_CPP='m68k_next_nextstep2'
HostArch_CPP='m68k'
HostVendor_CPP='next'
HostOS_CPP='nextstep2'
;;
m68k-next-nextstep3)
HostPlatform_CPP='m68k_next_nextstep3'
HostArch_CPP='m68k'
HostVendor_CPP='next'
HostOS_CPP='nextstep3'
;;
i[[3456]]86-next-nextstep3)
HostPlatform=i386-next-nextstep3 # hack again
TargetPlatform=i386-next-nextstep3
BuildPlatform=i386-next-nextstep3
HostPlatform_CPP='i386_next_nextstep3'
HostArch_CPP='i386'
HostVendor_CPP='next'
HostOS_CPP='nextstep3'
;;
m68k-sun-sunos4*)
HostPlatform=m68k-sun-sunos4
TargetPlatform=m68k-sun-sunos4 #hack
BuildPlatform=m68k-sun-sunos4 #hack
HostPlatform_CPP='m68k_sun_sunos4'
HostArch_CPP='m68k'
HostVendor_CPP='sun'
HostOS_CPP='sunos4'
;;
mips-dec-ultrix*)
HostPlatform_CPP='mips_dec_ultrix'
HostArch_CPP='mipsel' # NB a little different
HostVendor_CPP='dec'
HostOS_CPP='ultrix'
;;
mips-sgi-irix*)
HostPlatform=mips-sgi-irix
TargetPlatform=mips-sgi-irix #hack
BuildPlatform=mips-sgi-irix #hack
HostPlatform_CPP='mips_sgi_irix'
HostArch_CPP='mipseb' # NB a little different
HostVendor_CPP='sgi'
HostOS_CPP='irix'
;;
powerpc-ibm-aix*)
HostPlatform=powerpc-ibm-aix
TargetPlatform=powerpc-ibm-aix #hack
BuildPlatform=powerpc-ibm-aix #hack
HostPlatform_CPP='powerpc_ibm_aix'
HostArch_CPP='powerpc'
HostVendor_CPP='ibm'
HostOS_CPP='aix'
;;
sparc-sun-sunos4*)
HostPlatform=sparc-sun-sunos4
TargetPlatform=sparc-sun-sunos4 #hack
BuildPlatform=sparc-sun-sunos4 #hack
HostPlatform_CPP='sparc_sun_sunos4'
HostArch_CPP='sparc'
HostVendor_CPP='sun'
HostOS_CPP='sunos4'
;;
sparc-sun-solaris2*)
HostPlatform=sparc-sun-solaris2
TargetPlatform=sparc-sun-solaris2 #hack
BuildPlatform=sparc-sun-solaris2 #hack
HostPlatform_CPP='sparc_sun_solaris2'
HostArch_CPP='sparc'
HostVendor_CPP='sun'
HostOS_CPP='solaris2'
;;
*)
echo "Unrecognised platform: $HostPlatform"
exit 1
;;
esac
echo "Which we'll canonicalise into: $HostPlatform"
test x"$HostPlatform" != x"$TargetPlatform" && echo "Target platform set to $TargetPlatform"
test x"$BuildPlatform" != x"$HostPlatform" && echo "Build platform set to $BuildPlatform"
BuildPlatform_CPP=$HostPlatform_CPP
TargetPlatform_CPP=$HostPlatform_CPP
BuildArch_CPP=$HostArch_CPP
TargetArch_CPP=$HostArch_CPP
BuildOS_CPP=$HostOS_CPP
TargetOS_CPP=$HostOS_CPP
BuildVendor_CPP=$HostVendor_CPP
TargetVendor_CPP=$HostVendor_CPP
dnl Cannot afford all these SUBSTs (because of braindead seds w/ 99 cmd limits)
dnl AC_SUBST(BuildPlatform)
AC_SUBST(HostPlatform)
AC_SUBST(TargetPlatform)
AC_SUBST(HostPlatform_CPP)
dnl AC_SUBST(BuildPlatform_CPP)
dnl AC_SUBST(TargetPlatform_CPP)
AC_SUBST(HostArch_CPP)
dnl AC_SUBST(BuildArch_CPP)
dnl AC_SUBST(TargetArch_CPP)
AC_SUBST(HostOS_CPP)
dnl AC_SUBST(BuildOS_CPP)
dnl AC_SUBST(TargetOS_CPP)
AC_SUBST(HostVendor_CPP)
dnl AC_SUBST(BuildVendor_CPP)
dnl AC_SUBST(TargetVendor_CPP)
# -------------------------------------------------------------------------
dnl
dnl * _GENERAL_ CONFIGURATION CHECKS
#
dnl ** are we at Glasgow?
#
# This stuff is in danger of going away..
#
if test -d /local/fp -a -d /users/fp/simonpj; then
echo "Brilliant! You must be a Glaswegian."
AT_GLASGOW=1
if test "x$prefix" = xNONE; then
prefix=/local/fp
echo "Assuming installation prefix of $prefix"
fi
if test "x$exec_prefix" = xNONE; then
# Sigh: the defn of exec_prefix does not include the bin* bit...
# WDP 94/07
exec_prefix=/local/fp
echo "Assuming binary installation prefix of $exec_prefix"
fi
else
AT_GLASGOW=0
fi
AC_SUBST(AT_GLASGOW)
test -n "$verbose" && echo " setting AT_GLASGOW to $AT_GLASGOW"
#
#
#
dnl ** does #! work?
#
AC_SYS_INTERPRETER()
#
dnl ** look for `perl', but watch out for version 4.035
#
AC_CHECK_PROG(PerlCmd,perl,$ac_dir/$ac_word)
if test -z "$PerlCmd"; then
echo "You must install perl before you can continue"
echo "Perhaps it is already installed, but not in your PATH?"
exit 1
else
$PerlCmd -v >conftest.out 2>&1
if egrep "version 4" conftest.out >/dev/null 2>&1; then
if egrep "Patch level: 35" conftest.out >/dev/null 2>&1; then
echo "
************************************************************************
Uh-oh...looks like you have Perl 4.035.
Perl version 4.035 has a bug to do with recursion that will bite if
you run the lit2texi script, when making Info files from
literate files of various sorts. Either use the current version
(4.036), an older version (e.g., perl 4.019) or apply the patch in
glafp-utils/perl-4.035-fixes to your 4.035 perl.
************************************************************************
"
fi
else
if egrep "version 5" conftest.out >/dev/null 2>&1; then
:
else
echo "I'm not sure if your version of perl will work,"
echo "but it's worth a shot, eh?"
fi
fi
rm -fr conftest*
fi
#
dnl ** does #!.../perl work? (sometimes it's too long...)
echo "checking if \`#!$PerlCmd' works in shell scripts"
echo "#!$PerlCmd"'
exit $1;
' > conftest
chmod u+x conftest
(SHELL=/bin/sh; export SHELL; ./conftest 69 > /dev/null)
if test $? -ne 69; then
echo "It does!"
else
echo "It doesn't! Perhaps \`#!$PerlCmd' is too long (often 32 characters max)"
exit 1
fi
rm -f conftest
#
dnl ** check if perl library is properly installed
# (by seeing if a "do 'getopts.pl'" works...
if $PerlCmd -e 'do "getopts.pl" || exit(1); exit(0);' > /dev/null 2>&1 ; then
:
else
echo "I think your perl library is misinstalled."
echo "The following script did not work:"
echo ' do "getopts.pl" || exit(1); exit(0);'
exit 1
fi
#
#
dnl ** look for GCC and find out which version
# Figure out which C compiler to use. Gcc is preferred.
# If gcc, make sure it's at least 2.1
#
AC_PROG_CC
if test -z "$GCC"; then
echo "You would be better off with gcc"
echo "Perhaps it is already installed, but not in your PATH?"
HaveGcc='NO'
else
gcc -v > conftest.out 2>&1
echo '/version (\d+)\.(\d+)/ && $1*10+$2 > 20 && print "YES";' > conftest.pl
HaveGcc=`eval $PerlCmd -n conftest.pl conftest.out`
if test -z "$HaveGcc"; then
echo "I'm not sure if your version of gcc will work,"
echo "but it's worth a shot, eh?"
HaveGcc='YES'
fi
rm -fr conftest*
fi
AC_SUBST(HaveGcc)
# Deprecated (AC_PROG_CC does it): AC_C_CROSS
#
dnl ** figure out how to do context diffs
# (NB: NeXTStep thinks diff'ing a file against itself is "trouble")
#
echo foo > conftest1
echo foo > conftest2
if diff -C 1 conftest1 conftest2 > /dev/null 2>&1 ; then
ContextDiffCmd='diff -C 1'
else
if diff -c1 conftest1 conftest2 > /dev/null 2>&1 ; then
ContextDiffCmd='diff -c1'
else
echo "Can't figure out how to do context diffs."
echo "Neither \`diff -C 1' nor \`diff -c1' works."
exit 1
fi
fi
rm -f conftest1 conftest2
AC_SUBST(ContextDiffCmd)
#
dnl ** look for a decent parser generator (bison preferred)
#
#
AC_CHECK_PROG(YaccCmd, bison, bison -y)
if test -z "$YaccCmd"; then
echo "Can't find bison out there..."
AC_CHECK_PROG(WhatCmd, what, what, :)
AC_CHECK_PROG(YaccCmd, yacc, $ac_dir/$ac_word)
if test -z "$YaccCmd"; then
echo "But that's okay...I can't find yacc either."
YaccCmd=:
else
$WhatCmd $YaccCmd > conftest.out
if egrep 'y1\.c 1\..*SMI' conftest.out >/dev/null 2>&1; then
echo "I don't trust your $YaccCmd; it looks like an old Sun yacc"
if test -f /usr/lang/yacc; then
echo "I'm going to use /usr/lang/yacc instead"
YaccCmd=/usr/lang/yacc
else
echo "I'm assuming the worst...no parser generator at all"
YaccCmd=:
fi
elif egrep 'y1\.c.*Revision: 4\.2\.6\.3.*DEC' conftest.out >/dev/null 2>&1; then
echo "I don't trust your $YaccCmd; it looks like a lame DEC yacc"
echo "I'm assuming the worst...no parser generator at all"
YaccCmd=:
else
echo "But that's okay...as far as I know, your yacc will work."
fi
rm -fr conftest*
fi
fi
dnl ** Find lex command (lex or flex) and library (-ll or -lfl)
#
AC_PROG_LEX
# -------------------------------------------------------------------------
#
dnl ** figure out how to invoke cpp directly (gcc -E is no good)
#
AC_PROG_CPP
if echo $CPP | egrep gcc >/dev/null 2>&1; then
echo > conftest.c
gcc -v -E conftest.c >/dev/null 2>conftest.out
echo '/(\S+\/cpp)/ && print "$1";' > conftest.pl
# GNUCPP: used in jmake.c (GnuCppCmd) and in mkdependC
# (where we could do with the usual pre-#defines)
GNUCPP="`eval $PerlCmd -n conftest.pl conftest.out`"
test -n "$verbose" && echo " setting GNUCPP to $GNUCPP"
# RAWCPP: we do not want *any* pre-#defines...
# (e.g., hscpp, mkdependHS)
RAWCPP="`eval $PerlCmd -n conftest.pl conftest.out` -traditional"
test -n "$verbose" && echo " setting RAWCPP to $RAWCPP"
rm -fr conftest*
fi
# ToDo: what are GNUCPP and RAWCPP if the above if didn't fire? WDP 95/02
AC_SUBST(GNUCPP)
AC_SUBST(RAWCPP)
#
dnl ** figure out how to do a BSD-ish install
#
AC_PROG_INSTALL
#
dnl ** figure out what arguments to feed to `ar'
#
AC_CHECK_PROG(ArCmd,ar,$ac_dir/$ac_word)
if test -z "$ArCmd"; then
echo "You don't seem to have ar...I have no idea how to make a library"
exit 1;
fi
if $ArCmd clqs conftest.a >/dev/null 2>/dev/null; then
ArCmd="$ArCmd clqs"
NeedRanLib=''
elif $ArCmd cqs conftest.a >/dev/null 2>/dev/null; then
ArCmd="$ArCmd cqs"
NeedRanLib=''
elif $ArCmd clq conftest.a >/dev/null 2>/dev/null; then
ArCmd="$ArCmd clq"
NeedRanLib='YES'
elif $ArCmd cq conftest.a >/dev/null 2>/dev/null; then
ArCmd="$ArCmd cq"
NeedRanLib='YES'
elif $ArCmd cq conftest.a 2>&1 | grep 'no archive members specified' >/dev/null 2>/dev/null; then
ArCmd="$ArCmd cq"
NeedRanLib='YES'
else
echo "I can't figure out how to use your $ArCmd"
exit 1
fi
rm -rf conftest*
test -n "$ArCmd" && test -n "$verbose" && echo " setting ArCmd to $ArCmd"
AC_SUBST(ArCmd)
#
dnl ** figure out if we need `ranlib'
#
if test -z "$NeedRanLib"; then
# we hackily override a few platforms on a case-by-case basis
case $HostPlatform in
i386-*-linuxaout)
NeedRanLib='YES'
;;
*) RANLIB=':'
;;
esac
test -n "$verbose" && echo " setting RANLIB to $RANLIB"
fi
if test -n "$NeedRanLib"; then
AC_PROG_RANLIB
fi
AC_SUBST(RANLIB)
#
#
dnl ** Check to see whether ln -s works
#
AC_PROG_LN_S()
AC_SUBST(LN_S)
#
dnl ** Find the path to sed **
AC_PATH_PROG(SedCmd,sed,$ac_dir/$ac_word)
#
# It better be around somewhere (we wouldn't
# exec this script properly if it wasn't!)
#
AC_SUBST(SedCmd)
#
dnl ** check for time command **
AC_PATH_PROG(TimeCmd,time,$ac_dir/$ac_word)
#
AC_SUBST(TimeCmd)
#
dnl ** check for tar **
#
# if GNU tar is named gtar, look for it first.
#
AC_PATH_PROGS(TarCmd,gtar tar,tar)
AC_SUBST(TarCmd)
#
dnl ** check for gzip/compress **
AC_PATH_PROGS(CompressCmd,gzip compress,gzip)
compress_nm=`basename $CompressCmd`
if test x"$compress_nm" = xgzip; then
CompressCmd="$CompressCmd -d"
CompressSuffix="gz"
else
CompressSuffix="Z"
fi
AC_SUBST(CompressCmd)
AC_SUBST(CompressSuffix)
#
dnl ** check for installed happy binary
#
AC_PATH_PROG(HappyCmd,happy)
AC_SUBST(HappyCmd)
#
#
dnl ** check for installed lx binary
#
AC_PATH_PROG(LxCmd,lx)
AC_SUBST(LxCmd)
#
#
dnl ** check for full ANSI header (.h) files
#
AC_HEADER_STDC
#
dnl ** check for specific header (.h) files that we are interested in
#
AC_CHECK_HEADERS(dirent.h fcntl.h grp.h malloc.h memory.h nlist.h pwd.h siginfo.h signal.h stdlib.h string.h sys/fault.h sys/file.h sys/mman.h sys/param.h sys/procfs.h sys/resource.h sys/signal.h sys/socket.h sys/stat.h sys/syscall.h sys/time.h sys/timeb.h sys/timers.h sys/times.h sys/types.h sys/utsname.h sys/vadvise.h sys/wait.h termios.h time.h types.h unistd.h utime.h vfork.h readline/readline.h )
#
dnl ** check if it is safe to include both <time.h> and <sys/time.h>
#
AC_HEADER_TIME
#
dnl ** how do we get a timezone name?
#
AC_STRUCT_TIMEZONE
#
dnl ** determine the type of signal()
#
AC_TYPE_SIGNAL
#
dnl ** check for specific library functions that we are interested in
#
AC_CHECK_FUNCS(access ftime getclock getpagesize getrusage gettimeofday mktime mprotect setitimer stat sysconf timelocal times vadvise vfork)
#
dnl ** can we get alloca?
#
AC_FUNC_ALLOCA
#
dnl ** determine whether or not const works
#
AC_C_CONST
#
dnl ** check for leading underscores in symbol names
# We assume that they _aren't_ there if anything goes wrong.
#
echo checking for a leading underscore in symbol names
AC_TRY_RUN(
[#ifdef HAVE_NLIST_H
#include <nlist.h>
struct nlist xYzzY[] = {{"_xYzzY", 0},{0}};
#endif
main(argc, argv)
int argc;
char **argv;
{
#ifdef HAVE_NLIST_H
if(nlist(argv[0], xYzzY) == 0 && xYzzY[0].n_value != 0)
exit(0);
#endif
exit(1);
}], LeadingUnderscore='YES', LeadingUnderscore='NO', LeadingUnderscore='YES')
test -n "$verbose" && echo " setting LeadingUnderscore to $LeadingUnderscore"
AC_SUBST(LeadingUnderscore)
AC_OUTPUT(mk/config.mk, echo timestamp > mk/stamp-h )
#
# It'll break soon enough if it didn't, but we perform a sanity
# check here on the generated config.mk file to see if the
# sed that was used is of the well-behaved sort.
#
#grep @ mk/config.mk > conftest.out
#if grep -v '# enclosed in @at-signs@.' conftest.out >/dev/null 2>&1; then
# :
#else
# echo 'Hmm..suspicious, did the configure script perform all the @..@ substitutions in mk/config.mk?..';
# grep -v '# enclosed in @at-signs@.' conftest.out /dev/null
#fi
#rm -f conftest*
echo ''
echo '************************************************'
echo '*** NOW DO: gmake boot followed by gmake all'
echo '************************************************'
exit 0